;************** -   AVR ***************
;*
;* - MT10S1
;*  HP03S
;*  DS1624
;*  Atmega8
;*   AVR: 4 
;*  TWI (I2C),   , 100 
;* :
;* InitLCD:  -  8- 
;* ReadD1:      HP03S  hex-
;* ReadD2:      HP03S  hex-
;* CalcPress:     hex- 
;* HexBCD:      hex-  
;* XBruchD:      hex-  
;* InitDS:   DS1624
;* ReadDS:     DS1624
;* Press:     LCD
;* PozN:      LCD
;* View:    
;* Timer_Int: /    
;*  : b1101100111101111
;* :
;*  , "AVR-RISC "
;*  , "?   !"
;*  , " AVR  Tiny  Mega  ATMEL"  
;***************************************************************************
.nolist
.include "m8def.inc"
.list
;*****  

.def  m0 = r0       ;  /   
.def  m1 = r1
.def  m2 = r2
.def  m3 = r3
.def  m4 = r4
.def  m5 = r5
.def  m6 = r6
.def  m7 = r7
.def  m8 = r8       ;   3
.def  m9 = r9       ;   4
.def  BCD0 = r24	;  1  2    LCD
.def  BCD1 = r25	;  3  4    LCD
.def  hexL1 = r10   ;       
.def  hexH1 = r11   ;     DS1624                  
.def  hexL2 = r12   ;      
.def  hexH2 = r15 
.def  bufL = r14    ;     
.def  time = r16	;   
.def  tim2 = r17	;   2
.def  tmp1 = r19	;   1
.def  tmp2 = r20	;   2
.def  prm1 = r21	;  
.def  Cnt  = r23	;  
.def  cpyL = r18	;  
.def  tim1 = r22	;   1, /    1

;***** *****

.equ  XCLR = 0      ;   HP03S
.equ  RS   = 1	    ; Register Select =  1  C
.equ  RW   = 2	    ; R/W =  2  C (/WR)
.equ  Ena  = 3	    ; Enable Impuls =  3  C
.equ  SDA  = 4      ;  TWI
.equ  SCL  = 5      ;  TWI
.equ  BF   =PortD7	;   =  7  D
;          HP03S!!! 
.equ  C1H   =$39	;  C1,  
.equ  C1L   =$03	;  C1,  
.equ  C2H   =$03	;  C2,  
.equ  C2L   =$C1	;  C2,  
.equ  C3H   =$01	;  C3,  
.equ  C3L   =$12	;  C3,  
.equ  C4H   =$00	;  C4,  
.equ  C4L   =$8B	;  C4,  
.equ  C5H   =$8C	;  C5,  
.equ  C5L   =$96	;  C5,  
.equ  C6H   =$15	;  C6,  
.equ  C6L   =$14	;  C6,  
.equ  C7L   =$09	;  C7,  
.equ  C7H   =$C4	;  C7,  
.equ  Asen   =$07	;   A
.equ  Bsen   =$10	;   B
.equ  Csen   =$06	;   C

.cseg

.org 0
rjmp  Initial	;      

.org 8          ;   /    
rjmp Timer_Int

SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall Ausgabe
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall Ausgabe
ret

Ausgabe:	;   = 8 
out   PortD,prm1	;  /   D
sbi   PortC,Ena	;   
nop
nop    	    ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
clr   tmp1
out   DDRD,tmp1	;  D = 
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB2:
sbi   PortC,Ena	;   
nop
nop	            ;  . 320   
in    tmp1,PinD	;  BF    
cbi   PortC,Ena	;   
nop
sbrc  tmp1,BF	;   ,  -  (BF=0)
rjmp  WB2
cbi   PortC,RW	;   =  -
ser   tmp1
out   DDRD,tmp1	;  D = 
ret

Wait50us:	    ;    = 4 
ldi   time,65	;  
Wait51:
dec   time
brne  Wait51
ret

Wait150us:	    ;    = 4 
rcall wait50us
rcall wait50us
rcall wait50us
ret

Wait5ms:	    ;    = 4 
ldi   tim2,100	;  
Wait501:
rcall wait50us
dec   tim2
brne  Wait501
ret

InitLCD:

rcall wait5ms
rcall wait5ms
rcall wait5ms	;   20    
rcall wait5ms
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;    -
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;  
rcall wait50us	;   50k 
ldi   prm1,$30	; $30:  ,8  
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$38  ;  
rcall WaitBusy	;   -  	
rcall SendCom	;    -
ldi   prm1,$08	; $08:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	; $01:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$06	; $06:    
rcall WaitBusy	;   -  
rcall SendCom	;  	
rcall wait150us	;   150 
ret

Initial:

ldi   tmp1,High(RamEnd)  ;  
out   sph,tmp1
ldi   tmp1,Low(RamEnd)
out   spl,tmp1	   
clr   tmp1	       ;  tmp1 
out   PortC,tmp1   ; SCL,SDA,RW,Ena,RS,XCLR=0 
ldi   tmp1,$0E	   ;  3,2,1 = 1
out   DDRC,tmp1	   ;  3,2,1,- ,  - 
ser   tmp1	       ;  tmp1
out   DDRD,tmp1	   ;  D - 
ldi   tim1,2       ;  , /    1
ldi   R31,$3F      ;     , ? 
ldi   tmp1,5	   ;  
out   TCCR0,tmp1   ;  T/C0,  . = 1024
ldi   tmp1,$0C 
out   TWBR,tmp1    ;     (100kHz)
ldi  tmp1,0        
out  TCNT1H,tmp1   ;    0
out  TCNT1L,tmp1
ldi  tmp1,5
out  TCCR1B,tmp1   ;  ,   1024
ldi  tmp1,4       
out  TIMSK,tmp1    ;    
sei                ;   

rcall InitLCD      ;  -

Next:           ;   
rcall View        
rcall ReadD2
rcall ReadD1
rcall CalcPress
rcall HexBCDm
rcall Press
rcall InitDS
rcall ReadDS
rcall HexBCD
rcall Poz2
rcall XBruchD
rcall Poz6
rjmp  Next

Wait250:	        ;   250 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   time,4  	    ; 4   
Wait:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0 
dec   time
brne  Wait	        ; 4  = 250 
ret

ReadD1:     ;    HP03S

cbi   DDRC,0   ;   HP03S
ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait1:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait1

ldi  tmp1,$EE ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait2:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait2

ldi  tmp1,$FF ; ,   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait3:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait3

ldi  tmp1,$F0 ; ,   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait4:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait4

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1

rcall Wait250

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait5:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait5

ldi  tmp1,$EE ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait6:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait6

ldi  tmp1,$FD ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait7:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait7

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait11:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait11

ldi  tmp1,$EF ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait8:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait8
       
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) | (0<<TWSTA)
out  TWCR,tmp1
wait12:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait12
in   hexH1,TWDR
 
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWEA) | (0<<TWSTA)
out  TWCR,tmp1
wait10:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait10
in   hexL1,TWDR

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
sbi   DDRC,0  ;   HP03S
ret

ReadD2:   ;   HP03S

cbi   DDRC,0   ;   HP03S
ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait13:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait13

ldi  tmp1,$EE ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait14:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait14

ldi  tmp1,$FF ; ,   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait15:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait15

ldi  tmp1,$E8 ; ,   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait16:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait16

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1

rcall Wait250


ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait17:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait17

ldi  tmp1,$EE ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait18:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait18

ldi  tmp1,$FD ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait19:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait19

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait20:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait20

ldi  tmp1,$EF ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait21:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait21
  
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) | (0<<TWSTA)
out  TWCR,tmp1
wait22:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait22
in   hexH2,TWDR
 
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWEA) | (0<<TWSTA)
out  TWCR,tmp1
wait23:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait23
in   hexL2,TWDR

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
sbi   DDRC,0  ;   HP03S
ret

CalcPress:     ;    
mov   r26,hexL2         ;      
mov   r27,hexH2 
subi  r26,C5L           ;  (D2-C5),  
sbci  r27,C5H           ;  (D2-C5),   
brmi  CalcPress2        ; ,  (D2<C5)
rjmp  CalcPress1        ; ,  (D2>=C5)


CalcPress2:     ;  ,  (D2<C5)

;CalcdUT2
neg  R26              ;     
neg  R27
mov   m0,r26          ;     / 
mov   m1,r27           
mov   m2,r26          
mov   m3,r27
ldi  tmp1,0           ;   
mov  m7,tmp1			
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1
          
rcall MUL42

ldi  tmp1,$FF         ;    65535,(128   *4)-1,        
mov  m1,tmp1          ; B/2^C=16/64=1/4,(B=$10,C=$06), 1  
ldi  tmp1,$FF         ;  
mov  m0,tmp1

rcall DIV42
      
add   R26,m4         ;  (D2-C5)              
adc   R27,m5
                     ; dUT2    r27:r26
                   
;CalcOFF2

mov   m0,r26          ;  dUT2   / 
mov   m1,r27
ldi   tmp1,$75        ;   (4-1024)=139-1024=-885,$0375=0-$0C8B,                 
mov   m2,tmp1         ;   / ,C4=139
ldi   tmp1,$03     
mov   m3,tmp1
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

ldi  tmp1,$40         ;    16384,(2^14)     
mov  m1,tmp1
ldi  tmp1,0
mov  m0,tmp1

rcall DIV42

ldi  tmp1,C2H         ;  2=961 ($03C1)   
mov  m3,tmp1
ldi  tmp1,C2L
mov  m2,tmp1
add  m2,m4            ;    
adc  m3,m5            ;       
ldi  tmp1,0           ;   = 4   
mov  m1,tmp1
ldi  tmp1,4
mov  m0,tmp1
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

mov  m9,m5
mov  m8,m4            ; OFF2    m9:m8
 
;CalcSENS2

mov  m0,R26           ;  dUT2   
mov  m1,R27
ldi  tmp1,C3L         ;  3=$0112   
mov  m2,tmp1
ldi  tmp1,C3H
mov  m3,tmp1
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

ldi  tmp1,$04        ;  2^10 ($0400)   
mov  m1,tmp1
ldi  tmp1,0
mov  m0,tmp1

rcall DIV42

ldi  tmp1,C1L        ;   1=14595($3903) 
sub  tmp1,m4                      
ldi  tmp2,C1H
sbc  tmp2,m5
mov  m2,tmp1         ;   CalcSENS2   / 
mov  m3,tmp2         ; (C1>C3*dUT2/2^10)
                     ; SENS    m3:m2
;CalcX2

mov   r26,hexL1       ;      
mov   r27,hexH1 
subi  r26,$00         ;  (D1-7168),  
sbci  r27,$1C         ;  (D1-7168),   
mov   m0,r26          ;   (D1-7168)   / 
mov   m1,r27
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

ldi  tmp1,$40          ;  2^14 ($4000)   
mov  m1,tmp1
ldi  tmp1,$00 
mov  m0,tmp1

rcall DIV42

sub  m4,m8             ;    OFF2
sbc  m5,m9             ;    OFF2    
mov  m3,m5             ;  X2   / 
mov  m2,m4
                   ; X2    m3:m2
;CalcPhPa

ldi  tmp1,$00          ;  10 ($000A)    / 
mov  m1,tmp1
ldi  tmp1,$0A
mov  m0,tmp1
ldi  tmp1,0            ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42 
                
ldi  tmp1,$00          ;  2^5 ($0020)   
mov  m1,tmp1
ldi  tmp1,$20 
mov  m0,tmp1

rcall DIV42

ldi  tmp1,C4L          ;  7=2500($09C4)  
add   m4,tmp1                      
ldi  tmp1,C4H
adc   m5,tmp1
                       ; P (hPa)    m5:m4
;CalcPTorr

mov  m1,m5             ;  P (hPa)    / 
mov  m0,m4
ldi  tmp1,$03          ;  1000 ($03E8)    / 
mov  m3,tmp1
ldi  tmp1,$E8
mov  m2,tmp1
ldi  tmp1,0            ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42
 
ldi  tmp1,$34          ;  13332 ($3414)   
mov  m1,tmp1
ldi  tmp1,$14
mov  m0,tmp1

rcall DIV42
                       ; P (Torr)    m5:m4
mov  bufL,m4           ;                            
mov  hexL1,m4          ;                  
mov  hexH1,m5
ret

CalcPress1:         ;  ,  (D2>=C5)

;CalcdUT1

mov   m0,r26          ;     / 
mov   m1,r27           
mov   m2,r26          
mov   m3,r27
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1
          
rcall MUL42

ldi  tmp1,Asen         ;  =7
mov  m0,tmp1
ldi  tmp1,0
mov  m1,tmp1
mov   m2,m4            ;  (D2-C5)*(D2-C5)
mov   m3,m5

rcall MUL42

ldi  tmp1,$40          ;    16384,(128  )        
mov  m1,tmp1
ldi  tmp1,0
mov  m0,tmp1

rcall DIV42

ldi  tmp1,0           ;    64,2^C=2^6=64,(C=6)        
mov  m1,tmp1
ldi  tmp1,$40
mov  m0,tmp1

rcall DIV42

sub  r26,m4           ;    
sbc  r27,m5           ;       
                      ; dUT    r27:r26
;CalcOFF1

mov   m0,r26          ;  dUT   / 
mov   m1,r27
ldi   tmp1,$75        ;   (4-1024)=139-1024=-885,$0375=0-$0C8B,           
mov   m2,tmp1         ;   / 
ldi   tmp1,$03     
mov   m3,tmp1
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

ldi  tmp1,$40         ;    16384,(2^14)     
mov  m1,tmp1
ldi  tmp1,0
mov  m0,tmp1

rcall DIV42

ldi  tmp1,C2H         ;  2=961 ($03C1)   
mov  m3,tmp1
ldi  tmp1,C2L
mov  m2,tmp1
sub  m2,m4            ;    
sbc  m3,m5            ;       
ldi  tmp1,0           ;   = 4   
mov  m1,tmp1
ldi  tmp1,4
mov  m0,tmp1
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

mov  m9,m5
mov  m8,m4            ; OFF    m9:m8

;CalcSENS1

ldi  tmp1,C3H         ;  3=274 ($0112)   
mov  m3,tmp1
ldi  tmp1,C3L
mov  m2,tmp1
mov   m0,r26          ;  dUT   / 
mov   m1,r27
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

ldi  tmp1,$04         ;  2^10 ($0400)   
mov  m1,tmp1
ldi  tmp1,0
mov  m0,tmp1

rcall DIV42

ldi  tmp1,C1L         ;  1=14595($3903)  
add   m4,tmp1                      
ldi  tmp1,C1H
adc   m5,tmp1
                    ; SENS    m5:m4
;CalcX1

mov   r26,hexL1       ;      
mov   r27,hexH1 
subi  r26,$00         ;  (D1-7168),  
sbci  r27,$1C         ;  (D1-7168),   
mov   m0,r26          ;   (D1-7168)   / 
mov   m1,r27
mov   m2,m4           ;  SENS   / 
mov   m3,m5
ldi  tmp1,0           ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42

ldi  tmp1,$40          ;  2^14 ($4000)   
mov  m1,tmp1
ldi  tmp1,$00 
mov  m0,tmp1

rcall DIV42

sub  m4,m8             ;    OFF
sbc  m5,m9             ;    OFF    
mov  m3,m5             ;  X   / 
mov  m2,m4
                       ; X    m3:m2
;CalcPhPa

ldi  tmp1,$00          ;  10 ($000A)    / 
mov  m1,tmp1
ldi  tmp1,$0A
mov  m0,tmp1
ldi  tmp1,0            ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42 
                
ldi  tmp1,$00          ;  2^5 ($0020)   
mov  m1,tmp1
ldi  tmp1,$20 
mov  m0,tmp1

rcall DIV42

ldi  tmp1,C7L          ;  7=2500($09C4)  
add   m4,tmp1                      
ldi  tmp1,C7H
adc   m5,tmp1
                       ; P (hPa)    m5:m4
;CalcPTorr

mov  m1,m5             ;  P (hPa)    / 
mov  m0,m4
ldi  tmp1,$03          ;  1000 ($03E8)    / 
mov  m3,tmp1
ldi  tmp1,$E8
mov  m2,tmp1
ldi  tmp1,0            ;   
mov  m7,tmp1
mov  m6,tmp1
mov  m5,tmp1
mov  m4,tmp1

rcall MUL42
 
ldi  tmp1,$34          ;  13332 ($3414)   
mov  m1,tmp1
ldi  tmp1,$14
mov  m0,tmp1

rcall DIV42
                       ; P (Torr)    m5:m4
mov  bufL,m4           ;     
mov  hexL1,m4          ;                  
mov  hexH1,m5
ret

MUL42:              ;  
ldi  tmp1,0x10

MUL1: 
mov  tmp2,m2
ror  tmp2
brcc  MUL2
mov  tmp2,m6
add  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
adc  tmp2,m1
mov  m7,tmp2

MUL2:
mov  tmp2,m7
ror  tmp2
mov  m7,tmp2
mov  tmp2,m6
ror  tmp2

mov  m6,tmp2
mov  tmp2,m5
ror  tmp2

mov  m5,tmp2
mov  tmp2,m4
ror  tmp2

mov  m4,tmp2
mov  tmp2,m3
ror  tmp2

mov  m3,tmp2
mov  tmp2,m2
ror  tmp2

mov  m2,tmp2
dec  tmp1
cpi  tmp1,0
brne MUL1
ret

DIV42:        ;  

ldi  tmp1,0x10

DCLK42:

clc
mov  tmp2,m4
rol  tmp2
mov  m4,tmp2
mov  tmp2,m5
rol  tmp2
mov  m5,tmp2
mov  tmp2,m6
rol  tmp2
mov  m6,tmp2
mov  tmp2,m7
rol  tmp2
mov  m7,tmp2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  tmp2,m6
sbc  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
sbc  tmp2,m1
mov  m7,tmp2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  tmp2,m6
add  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
adc  tmp2,m1
mov  m7,tmp2
PER4:
dec  tmp1
cpi  tmp1,0
brne DCLK42
ret
 
HexBCDm:	    ; xxxx (Hex) -> bcde (BCD)
rcall Div10m	; hexH:hexL / 10,  -  tmp1
mov   BCD0,tmp1	;  -  hexH:hexL, tmp1 =  1
rcall Div10m	;  =  2
swap  tmp1	    ;  2    
or    BCD0,tmp1	;   2  1  BCD0
rcall Div10m	;  =  3
mov   BCD1,tmp1	;  BCD1
rcall Div10m	;  =  4
swap  tmp1	    ;  4    
or    BCD1,tmp1	;   4  3  BCD1
ret

Div10m:	        ;  hexH:hexL  10,
	            ;    hexH:hexL,  -  tmp1
clr  tmp1
lsl  hexL1
rol  hexH1
rol  tmp1       ;      10
lsl  hexL1	    ;       
rol  hexH1   	;    0
rol  tmp1
lsl  hexL1
rol  hexH1
rol  tmp1
lsl  hexL1
rol  hexH1
rol  tmp1
lsl  hexL1
rol  hexH1
rol  tmp1
lsl  hexL1
rol  hexH1
rol  tmp1
ldi  cnt,10	    ;    10 s
Loop10m:
lsl  hexL1	    ;     1 
rol  hexH1
rol  tmp1    	;   tmp1
subi tmp1,10	; :  > 10 ?
brlo HBm1   	    ; ,  
inc  hexL1       ;     1
rjmp HBm2
HBm1:
subi tmp1,-10	;   
HBm2:
dec  cnt    	;   
brne Loop10m	; ,     
ret

HexBCD:	        ; xx (Hex) -> 0abc (BCD)
rcall Div10	    ; hexH / 10, -  tmp1
mov   BCD0,tmp1	;   hexH, tmp1 =  1
rcall Div10
swap  tmp1      ;  2   
or    BCD0,tmp1 ;   2  1  BCD0 
rcall Div10	
mov   BCD1,tmp1	;   4  3  BCD1 
ret

XBruchD:	    ; 0,ab (HEX) -> 0,4321 (BCD)
rcall Mul10	
swap  tmp1	    ;  tmp1 =  4
mov   BCD1,tmp1	;  4   BCD1
rcall Mul10	
or    BCD1,tmp1	;   4  3  BCD1
rcall Mul10	
swap  tmp1	    ;  2    
mov   BCD0,tmp1	; 2     BCD0
rcall Mul10	
or    BCD0,tmp1	;   2  1  BCD0
ret

Div10:	
clr  tmp1
lsl  hexH1
rol  tmp1	    ;     10  
ldi  cnt,7	    ;   7 
Loop10:
lsl  hexH1	    ;     1 
rol  tmp1	    ;   tmp1
subi tmp1,10	; ;  > 10 ?
brlo HB1	    ; ,  
inc  hexH1       ;    1
rjmp HB2
HB1:
subi tmp1,-10	;   
HB2:
dec  cnt	    ;   
brne Loop10	
ret
Mul10:	
clr  tmp1	    ; ...  -  tmp1
lsl  hexL1	    ;   2
rol  tmp1	    ; 
mov  cpyL,hexL1	;   
mov  tmp2,tmp1
lsl  cpyL	    ;   2 ( -  4)
rol  tmp1	    ; 
lsl  cpyL	    ;   2 ( -  8)
rol  tmp1	    ; 
add  hexL1,cpyL	;    ( x 2)
adc  tmp1,tmp2	;  0...9   tmp1
ret

InitDS:

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait24:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait24

ldi  tmp1,$90   ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait25:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait25

ldi  tmp1,$AC  ; ,   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait26:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait26

ldi  tmp1,$00  ;     
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait27:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait27

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1

rcall Wait5ms  ; , 15 
rcall Wait5ms
rcall Wait5ms

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait28:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait28

ldi  tmp1,$90   ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait29:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait29

ldi  tmp1,$EE  ; ,  
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait30:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait30

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

ReadDS:

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait31:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait31

ldi  tmp1,$90   ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait32:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait32

ldi  tmp1,$AA    ; ,  
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait33:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait33

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait34:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait34

ldi  tmp1,$91   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait35:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait35
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) | (0<<TWSTA)
out  TWCR,tmp1
wait36:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait36

in   hexH1,TWDR
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWEA) | (0<<TWSTA)
out  TWCR,tmp1
wait37:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait37

in   hexL1,TWDR

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1

bst  hexH1,7     ;     
brtc Positiv     ; ,   
neg  hexL1       ;     
neg  hexH1       ;    com 
rcall Poz0       ;   
nop
ret

Positiv:         ;   "", 

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$2B   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
nop
ret

Poz0:            ;   "", 

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$2D   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ret

Poz2:            ;    

andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   3
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   tmp2,BCD0  ;  BCD0  tmp2
swap  BCD0       ;    
andi  BCD0,$0F   ; 
ori   BCD0,$30   ;    
mov   prm1,BCD0  ;   2
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   BCD0,tmp2  ;  BCD0 
andi  BCD0,$0F   ; 
ori   BCD0,$30   ;    
mov   prm1,BCD0  ;   1
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$2E   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ret

Poz6:            ;    

mov   tmp2,BCD1  ;  BCD1  tmp2
swap  BCD1       ;    
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   4
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   BCD1,tmp2  ;  BCD1 
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   3
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$99   ;   
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$C0   ;   9
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$43   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
rcall  Wait250     ;  3.5 
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
ret

Press:           ;   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$20   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   3
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   tmp2,BCD0  ;  BCD0  tmp2
swap  BCD0       ;    
andi  BCD0,$0F   ; 
ori   BCD0,$30   ;    
mov   prm1,BCD0  ;   2
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   BCD0,tmp2  ;  BCD0 
andi  BCD0,$0F   ; 
ori   BCD0,$30   ;    
mov   prm1,BCD0  ;   1
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$5F   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$54   ;   T
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$6F   ;   o
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$72   ;   r
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$C0   ;   9
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$72   ;   r
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   prm1,R31   ;  ,"", ""  "".
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
rcall  Wait250   ;  3.5 
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
rcall  Wait250
ret

View:            ;  

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$85   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$54   ;   T
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$45   ;   E
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$52   ;   R
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$4D   ;   M
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$4F   ;   O
rcall WaitBusy	 ;   -  
rcall SendDat	 ;  
ldi   prm1,$42   ;   B
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$41   ;   A
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$C0   ;   9
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$52   ;   R.
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$84   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
rcall  Wait250   ;  1.0 
rcall  Wait250
rcall  Wait250
rcall  Wait250
ret

Timer_Int:

in  R28,SREG     ;    
dec  tim1        ;  
cpi  tim1,0      ;   
breq Monitor     ;   ,  0.
out  SREG,R28    ;    
sei              ;   
reti             ;   /  

Monitor:

mov  R29,bufL    ;       
cp   R30,bufL    ;      
breq Equals      ; ,  
brpl Plus        ; ,     
ldi  R31,$D9     ;    , " "
mov  R30,R29     ;       
ldi  tim1,$FF    ;     $FF,  
out  SREG,R28    ;    
sei              ;   
reti             ;   /  
Plus:
ldi  R31,$DA     ;    , " "
mov  R30,R29     ;       
ldi  tim1,$FF    ;     $FF,  
out  SREG,R28    ;    
sei              ;   
reti             ;   /  
Equals:
ldi  R31,$3D     ;    , ""
mov  R30,R29     ;       
ldi  tim1,$FF    ;     $FF,  
out  SREG,R28    ;    
sei              ;   
reti             ;   /  




             
