;**************    HP03S ***************
;*
;* - MT10S1
;*  HP03S
;*  Atmega8
;*   AVR: 4 
;*  TWI (I2C),   , 100 
;* :
;* InitLCD:  -  8- 
;* EEWrite:    EEPROM MK
;* ReadCoef;  /       
;*  : b1101100111101111
;* :
;*  , "AVR-RISC "
 
;***************************************************************************

.nolist
.include "m8def.inc"
.list

;*****  

.def  hexL1 = r10   ;  -   
.def  hexH1 = r11   ;  -                   
.def  time = r16	;   
.def  tim2 = r17	;   2
.def  tmp1 = r19	;   1
.def  tmp2 = r20	;   2
.def  prm1 = r21	;  
.def  EEdwr = r22	;  

;***** 

.equ  XCLR = 0      ;   HP03S
.equ  RS   = 1	    ; Register Select =  1  C
.equ  RW   = 2	    ; R/W =  2  C (/WR)
.equ  Ena  = 3	    ; Enable Impuls =  3  C
.equ  SDA  = 4      ;  TWI
.equ  SCL  = 5      ;  TWI
.equ  BF   =PortD7	;   =  7  D


.cseg

.org 0
rjmp  Initial	;      

SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall Ausgabe
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall Ausgabe
ret

Ausgabe:	;   = 8 
out   PortD,prm1	;  /   D
sbi   PortC,Ena	;   
nop
nop    	    ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
clr   tmp1
out   DDRD,tmp1	;  D = 
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB2:
sbi   PortC,Ena	;   
nop
nop	            ;  . 320   
in    tmp1,PinD	;  BF    
cbi   PortC,Ena	;   
nop
sbrc  tmp1,BF	;   ,  -  (BF=0)
rjmp  WB2
cbi   PortC,RW	;   =  -
ser   tmp1
out   DDRD,tmp1	;  D = 
ret

Wait50us:	    ;    = 4 
ldi   time,65	;  
Wait51:
dec   time
brne  Wait51
ret

Wait150us:	    ;    = 4 
rcall wait50us
rcall wait50us
rcall wait50us
ret

Wait5ms:	    ;    = 4 
ldi   tim2,100	;  
Wait501:
rcall wait50us
dec   tim2
brne  Wait501
ret

InitLCD:

rcall wait5ms
rcall wait5ms
rcall wait5ms	;   20    
rcall wait5ms
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;    -
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;  
rcall wait50us	;   50k 
ldi   prm1,$30	; $30:  ,8  
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$38  ;  
rcall WaitBusy	;   -  	
rcall SendCom	;    -
ldi   prm1,$08	; $08:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	; $01:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$06	; $06:    
rcall WaitBusy	;   -  
rcall SendCom	;  	
rcall wait150us	;   150 
ret

Initial:

ldi   tmp1,High(RamEnd)  ;  
out   sph,tmp1
ldi   tmp1,Low(RamEnd)
out   spl,tmp1	   
clr   tmp1	       ;  tmp1 
out   PortC,tmp1   ; SCL,SDA,RW,Ena,RS,XCLR=0 
ldi   tmp1,$0E	   ;  3,2,1 = 1
out   DDRC,tmp1	   ;  3,2,1,- ,  - 
ser   tmp1	       ;  tmp1
out   DDRD,tmp1	   ;  D - 
ldi   tmp1,$0C 
out   TWBR,tmp1    ;     (100kHz)

rcall InitLCD      ;  -
rjmp  Next

ReadCoef:

ldi   R31,0      
ldi   R30,$60  ;    
cbi   DDRC,0   ;   EEPROM HP03S
sbi   DDRC,0   
ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait37:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait37

ldi  tmp1,$A0   ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait38:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait38

ldi  tmp1,$10    ;    EEPROM HP03S
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait39:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait39

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait40:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait40

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWSTA)
out  TWCR,tmp1
wait41:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait41
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait42:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait42
in   hexH1,TWDR
st   Z+,hexH1   ;      1

                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait43:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait43
in   hexL1,TWDR
st   Z+,hexL1    ;      1
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait44:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait44
in   hexH1,TWDR
st   Z+,hexH1   ;      2
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait45:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait45
in   hexL1,TWDR
st   Z+,hexL1    ;      2
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait46:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait46
in   hexH1,TWDR
st   Z+,hexH1   ;      3
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait47:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait47
in   hexL1,TWDR
st   Z+,hexL1    ;      3
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait48:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait48
in   hexH1,TWDR
st   Z+,hexH1   ;      4
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait49:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait49
in   hexL1,TWDR
st   Z+,hexL1    ;      4
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait50:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait50
in   hexH1,TWDR
st   Z+,hexH1   ;      5
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait52:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait52
in   hexL1,TWDR
st   Z+,hexL1    ;      5
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait53:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait53
in   hexH1,TWDR
st   Z+,hexH1   ;      6
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait54:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait54
in   hexL1,TWDR
st   Z+,hexL1    ;      6
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait55:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait55
in   hexH1,TWDR
st   Z+,hexH1   ;      7
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait56:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait56
in   hexL1,TWDR
st   Z+,hexL1    ;      7
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait57:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait57
in   hexH1,TWDR
st   Z+,hexH1   ;     A
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait58:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait58
in   hexL1,TWDR
st   Z+,hexL1    ;     B
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (1<<TWEA) 
out  TWCR,tmp1
wait59:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait59
in   hexH1,TWDR
st   Z+,hexH1   ;     C
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWSTO) | (0<<TWEA) 
out  TWCR,tmp1
wait60:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait60
in   hexL1,TWDR
st   Z,hexL1    ;     D
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

Next:           ;  

rcall ReadCoef
rcall WriteCoef
Next2:
rjmp  Next2
           
EEWrite:			; *****  "  EEPROM"
sbic	EECR,EEWE	;  EEWE  . 0, 
rjmp	EEWrite		;    
ldi	tmp1,0          ;      EEPROM - 
out	EEARH,tmp1	    ;      
out	EEARL,tmp2    	;      EEPROM -
	                ;     
out	EEDR,EEdwr	    ;   -    
sbi	EECR,EEMWE	    ;  EEMWE  
sbi	EECR,EEWE	    ;  EEWE :  
				    ;     4- ,  
				    ;     2 
ret

WriteCoef:         ;   EEPROM    HP03S

clr R31
ldi R30,$60         ;  1  
ld  EEdwr,Z+
ldi tmp2,11         ;    C1  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  1  
ldi tmp2,12         ;    C1  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  2  
ldi tmp2,13         ;    C2  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  2  
ldi tmp2,14         ;    C2  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  3  
ldi tmp2,15         ;    C3  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  3  
ldi tmp2,16         ;    C3  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  4  
ldi tmp2,17         ;    C4  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  4  
ldi tmp2,18         ;    C4  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  5  
ldi tmp2,19         ;    C5  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  5  
ldi tmp2,20         ;    C5  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  6  
ldi tmp2,21         ;    C6  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  6  
ldi tmp2,22         ;    C6  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  7  
ldi tmp2,23         ;    C7  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  7  
ldi tmp2,24         ;    C7  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  'A'  
ldi tmp2,25         ;   'A'  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  'B'  
ldi tmp2,26         ;   'B'  EEPROM
rcall EEWrite
ld  EEdwr,Z+        ;  'C''  
ldi tmp2,27         ;   'C'  EEPROM
rcall EEWrite
ld  EEdwr,Z         ;  'D''  
ldi tmp2,28         ;   'D'  EEPROM
rcall EEWrite
ret

.Exit


